import telebot
from telebot.types import ReplyKeyboardMarkup, KeyboardButton, InlineKeyboardMarkup, InlineKeyboardButton
import mysql.connector
import os
import shutil
from datetime import datetime
import requests
import random
import time
import base64
import json
from telebot import TeleBot
import logging

# Initialize bot with your Telegram Bot API token
bot = telebot.TeleBot("6930479837:AAEkVrVunK78VVTFM_zTLHsFuZJTz5ni1QQ")

# MySQL database connection
db = mysql.connector.connect(
    host="localhost",
    user="root",
    password="",
    database="foodwastagereduction"
)
cursor = db.cursor()

# Global dictionary to store user data during the donation process
user_data = {}

# Create directories for storing images if they don't exist
TEMP_FOLDER = os.path.join(os.getcwd(), 'temp')
UPLOAD_FOLDER = os.path.join(os.getcwd(), 'public', 'uploads', 'donations')
os.makedirs(TEMP_FOLDER, exist_ok=True)
os.makedirs(UPLOAD_FOLDER, exist_ok=True)

# M-Pesa API configuration (replace with your actual credentials)
MPESA_API_KEY = "uql9Dr2jcCl4D9AgTyUiW9GnoGDwdiCMH8ysSmlByiPCGtoJ"
MPESA_API_SECRET = "7138tJqQAzSPWzwB1dWkPCxVAzDTDXtAdZaQh1eIgsPQB1co75rBakxJjbXaTWQA"
MPESA_PASSKEY = "your_mpesa_passkey"
MPESA_SHORTCODE = "your_mpesa_shortcode"

# Set up logging
logging.basicConfig(level=logging.DEBUG, format='%(asctime)s - %(name)s - %(levelname)s - %(message)s')
logger = logging.getLogger(__name__)

# Welcome message and main menu
@bot.message_handler(commands=['start', 'help'])
def send_welcome(message):
    user = message.from_user
    welcome_text = (
        f"🌟 Welcome, {user.first_name}! 🌟\n\n"
        "Thank you for joining Feed Kenya's mission of 'Nourishing the nation'. \n\n"
        "How can we assist you today?"
    )
    send_main_menu(message, welcome_text)

def send_main_menu(message, text=None):
    markup = ReplyKeyboardMarkup(resize_keyboard=True, row_width=2)
    markup.add(
        KeyboardButton("🍲 Donate Food"),
        KeyboardButton("💧 Donate Water"),
        KeyboardButton("👚 Donate Clothing"),
        KeyboardButton("💰 Donate Money")
    )

    if text:
        bot.send_message(message.chat.id, text, reply_markup=markup, parse_mode='HTML')
    else:
        bot.send_message(message.chat.id, "🤔 What would you like to donate?", reply_markup=markup)

# Handle main menu options
@bot.message_handler(func=lambda message: True)
def handle_menu(message):
    logger.debug(f"Received message: {message.text}")
    user_id = message.from_user.id
    logger.debug(f"User ID: {user_id}")

    donation_options = {
        "🍲 Donate Food": "food",
        "💧 Donate Water": "water",
        "👚 Donate Clothing": "clothing",
        "💰 Donate Money": "money"
    }

    if message.text in donation_options:
        logger.debug(f"Recognized donation option: {message.text}")
        donation_type = donation_options[message.text]
        logger.debug(f"Extracted donation type: {donation_type}")

        if user_id in user_data and user_data[user_id].get('just_donated'):
            logger.debug("User just donated, asking to donate again")
            ask_donate_again(message)
        else:
            logger.debug(f"Starting donation process for {donation_type}")
            if donation_type == 'money':
                show_money_donation_options(message)
            else:
                start_donation(message, donation_type)
    else:
        logger.debug("Unrecognized message, sending error response")
        bot.reply_to(message, "I'm sorry, I didn't understand that. Please use the menu options.")

def show_money_donation_options(message):
    markup = InlineKeyboardMarkup()
    markup.row(
        InlineKeyboardButton("Mobile Money", callback_data="money_mobile"),
        InlineKeyboardButton("Bank Transfer", callback_data="money_bank"),
        InlineKeyboardButton("Cryptocurrency", callback_data="money_crypto")
    )
    bot.send_message(message.chat.id, "Please select a payment method:", reply_markup=markup)

@bot.callback_query_handler(func=lambda call: call.data.startswith('money_'))
def handle_money_donation_option(call):
    user_id = call.from_user.id
    option = call.data.split('_')[1]

    if option == 'mobile':
        user_data[user_id] = {'donation_type': 'money', 'payment_method': 'mobile'}
        bot.answer_callback_query(call.id)
        bot.send_message(call.message.chat.id, "You've selected Mobile Money (M-Pesa). Please enter the amount you'd like to donate in Kenyan Shillings.")
        bot.register_next_step_handler(call.message, process_money_amount)
    elif option == 'bank':
        bot.answer_callback_query(call.id)
        bank_details = (
            "Thank you for choosing to donate via bank transfer. Please use the following account details:\n\n"
            "ACCOUNT NAME: BENSON MAINA WAWERU\n"
            "ACCOUNT NUMBER: 1329695526\n"
            "ACCOUNT CURRENCY: KES\n"
            "BRANCH NAME: KCB THIKA ROAD MALL\n"
            "BANK CODE: 01\n"
            "BRANCH CODE: 011308\n"
            "SWIFT CODE: KCBLKENX\n\n"
            "After making the transfer, please provide us with the transaction details for verification."
        )
        bot.send_message(call.message.chat.id, bank_details)
        send_main_menu(call.message)
    elif option == 'crypto':
        bot.answer_callback_query(call.id)
        crypto_message = (
            "You've selected to donate via cryptocurrency. "
            "Please visit our Telegram wallet address for cryptocurrency donations: "
            "https://t.me/feedkenyawallet"
        )
        bot.send_message(call.message.chat.id, crypto_message)
        send_main_menu(call.message)


def ask_donate_again(message):
    markup = InlineKeyboardMarkup()
    markup.row(
        InlineKeyboardButton("✅ Yes, donate again", callback_data="donate_again_yes"),
        InlineKeyboardButton("❌ No, thanks", callback_data="donate_again_no")
    )
    bot.send_message(
        message.chat.id,
        "🎉 Thank you for your recent donation! Would you like to donate again?",
        reply_markup=markup
    )

@bot.callback_query_handler(func=lambda call: call.data.startswith('donate_again_'))
def handle_donate_again(call):
    if call.data == "donate_again_yes":
        bot.answer_callback_query(call.id)
        start_donation(call.message)
    else:
        bot.answer_callback_query(call.id)
        bot.send_message(call.message.chat.id, "Alright, thank you for your generosity! Is there anything else I can help you with?")
        # send_main_menu(call.message)

# Command handlers for About, Support, and Website
@bot.message_handler(commands=['about'])
def send_about_info(message):
    about_text = (
        "🌟 About Feed Kenya 🌟\n\n"
        "Feed Kenya is a nonprofit organization dedicated to addressing food insecurity "
        "and creating a more equitable food system in Kenya. Our mission is simple yet powerful: "
        "to collect surplus food and distribute it to those in need.\n\n"
        "We believe that no one should go hungry when there's excess food available. "
        "By bridging the gap between food waste and food scarcity, we're not just feeding people; "
        "we're nourishing communities and fostering hope.\n\n"
        "Join us in our journey to make Kenya a place where everyone has access to nutritious meals. "
        "Together, we can make a difference, one plate at a time."
    )
    bot.reply_to(message, about_text)

@bot.message_handler(commands=['support'])
def send_support_info(message):
    support_text = (
        "🤝 Support Feed Kenya 🤝\n\n"
        "Your support can make a real difference in the lives of many Kenyans. Here's how you can help:\n\n"
        "1. 🍲 Donate Food: Share your surplus food with those in need.\n"
        "2. 🙋‍♂️ Volunteer: Join our team of dedicated volunteers.\n"
        "3. 📢 Spread the Word: Share our mission with your friends and family.\n"
        "4. 💰 Financial Support: Every shilling counts in our fight against hunger.\n\n"
        "To learn more about these opportunities, please visit our website or contact us directly. "
        "Thank you for your generosity and compassion!"
    )
    bot.reply_to(message, support_text)

@bot.message_handler(commands=['website'])
def send_website_link(message):
    markup = InlineKeyboardMarkup()
    markup.add(InlineKeyboardButton("🌐 Open Feed Kenya Website", url="https://feedkenya.com"))
    bot.send_message(message.chat.id, "Click the button below to visit our website:", reply_markup=markup)

@bot.message_handler(commands=['contact'])
def send_contact_info(message):
    contact_text = (
        "📞 Contact Feed Kenya 📞\n\n"
        "We'd love to hear from you! Here's how you can reach us:\n\n"
        "📧 Email: info@feedkenya.org\n"
        "📱 Phone: +254 701 019860\n"
        "🌐 Website: www.feedkenya.com\n"
        "📍 Address: 123 Uhuru Gardens, Nairobi, Kenya\n\n"
        "Follow us on social media:\n"
        "Facebook: @FeedKenya\n"
        "Twitter: @Feed_Kenya\n"
        "Instagram: @feed_kenya_official\n\n"
    )
    bot.reply_to(message, contact_text)

def start_donation(message, donation_type):
    logger.debug(f"Inside start_donation. Donation type: {donation_type}")
    user_id = message.from_user.id
    user_data[user_id] = {'donation_type': donation_type, 'just_donated': False}
    logger.debug(f"Set user data: {user_data[user_id]}")

    if donation_type == 'food':
        logger.debug("Handling food donation")
        bot.reply_to(message, "🍲 Great! What kind of food would you like to donate?")
        bot.register_next_step_handler(message, process_food_name)
    elif donation_type == 'water':
        logger.debug("Handling water donation")
        bot.reply_to(message, "💧 Excellent! Please upload an image of the water you'd like to donate.")
        bot.register_next_step_handler(message, process_water_image)
    elif donation_type == 'clothing':
        logger.debug("Handling clothing donation")
        bot.reply_to(message, "👚 Wonderful! Please upload an image of the clothing you'd like to donate.")
        bot.register_next_step_handler(message, process_clothing_image)
    elif donation_type == 'money':
        logger.debug("Handling money donation")
        bot.reply_to(message, "💰 Thank you for your generosity! Please enter the amount you'd like to donate in Kenyan Shillings.")
        bot.register_next_step_handler(message, process_money_amount)
    else:
        logger.error(f"Unknown donation type: {donation_type}")
        bot.reply_to(message, "I'm sorry, there was an error processing your donation. Please try again.")

def process_food_name(message):
    user_id = message.from_user.id
    if user_id not in user_data or user_data[user_id].get('donation_type') != 'food':
        bot.reply_to(message, "Sorry, there was an error. Let's start over.")
        start_donation(message)
        return

    user_data[user_id]['food_name'] = message.text
    bot.reply_to(message, "Please upload an image of the food.")
    bot.register_next_step_handler(message, process_food_image)

def process_food_image(message):
    user_id = message.from_user.id
    if user_id not in user_data or user_data[user_id].get('donation_type') != 'food':
        bot.reply_to(message, "Sorry, there was an error. Let's start over.")
        start_donation(message)
        return

    if message.photo:
        file_info = bot.get_file(message.photo[-1].file_id)
        downloaded_file = bot.download_file(file_info.file_path)

        # Generate a unique filename
        file_extension = os.path.splitext(file_info.file_path)[1]
        filename = f"{file_info.file_unique_id}{file_extension}"
        temp_image_path = os.path.join(TEMP_FOLDER, filename)

        try:
            with open(temp_image_path, 'wb') as new_file:
                new_file.write(downloaded_file)
            user_data[user_id]['temp_image_path'] = temp_image_path
            user_data[user_id]['image_name'] = filename
            bot.reply_to(message, "Image received! How many plates of food are you donating?")
            bot.register_next_step_handler(message, process_food_quantity)
        except Exception as e:
            bot.reply_to(message, f"Sorry, there was an error saving the image. Please try again. Error: {str(e)}")
            bot.register_next_step_handler(message, process_food_image)
    else:
        bot.reply_to(message, "Please send an image of the food.")
        bot.register_next_step_handler(message, process_food_image)

def process_food_quantity(message):
    user_id = message.from_user.id
    if user_id not in user_data or user_data[user_id].get('donation_type') != 'food':
        bot.reply_to(message, "Sorry, there was an error. Let's start over.")
        start_donation(message)
        return

    try:
        quantity = float(message.text)
        user_data[user_id]['quantity'] = quantity
        bot.reply_to(message, "Thank you. Please provide your contact phone number.")
        bot.register_next_step_handler(message, process_phone_number)
    except ValueError:
        bot.reply_to(message, "Please enter a valid number for the quantity of food plates.")
        bot.register_next_step_handler(message, process_food_quantity)

def process_water_image(message):
    user_id = message.from_user.id
    if user_id not in user_data or user_data[user_id].get('donation_type') != 'water':
        bot.reply_to(message, "Sorry, there was an error. Let's start over.")
        start_donation(message)
        return

    if message.photo:
        file_info = bot.get_file(message.photo[-1].file_id)
        downloaded_file = bot.download_file(file_info.file_path)

        file_extension = os.path.splitext(file_info.file_path)[1]
        filename = f"{file_info.file_unique_id}{file_extension}"
        temp_image_path = os.path.join(TEMP_FOLDER, filename)

        try:
            with open(temp_image_path, 'wb') as new_file:
                new_file.write(downloaded_file)
            user_data[user_id]['temp_image_path'] = temp_image_path
            user_data[user_id]['image_name'] = filename
            bot.reply_to(message, "Image received! How many liters of water are you donating?")
            bot.register_next_step_handler(message, process_water_quantity)
        except Exception as e:
            bot.reply_to(message, f"Sorry, there was an error saving the image. Please try again. Error: {str(e)}")
            bot.register_next_step_handler(message, process_water_image)
    else:
        bot.reply_to(message, "Please send an image of the water.")
        bot.register_next_step_handler(message, process_water_image)

def process_water_quantity(message):
    user_id = message.from_user.id
    if user_id not in user_data:
        bot.reply_to(message, "Sorry, your session has expired. Please start over.")
        return

    try:
        quantity = float(message.text)
        user_data[user_id]['quantity'] = quantity
        bot.reply_to(message, "Thank you. Please provide your contact phone number.")
        bot.register_next_step_handler(message, process_phone_number)
    except ValueError:
        bot.reply_to(message, "Please enter a valid number for the quantity in liters.")
        bot.register_next_step_handler(message, process_water_quantity)

def process_clothing_image(message):
    user_id = message.from_user.id
    if user_id not in user_data or user_data[user_id].get('donation_type') != 'clothing':
        bot.reply_to(message, "Sorry, there was an error. Let's start over.")
        start_donation(message)
        return

    if message.photo:
        file_info = bot.get_file(message.photo[-1].file_id)
        downloaded_file = bot.download_file(file_info.file_path)

        file_extension = os.path.splitext(file_info.file_path)[1]
        filename = f"{file_info.file_unique_id}{file_extension}"
        temp_image_path = os.path.join(TEMP_FOLDER, filename)

        try:
            with open(temp_image_path, 'wb') as new_file:
                new_file.write(downloaded_file)
            user_data[user_id]['temp_image_path'] = temp_image_path
            user_data[user_id]['image_name'] = filename
            bot.reply_to(message, "Image received! Please provide a brief description of the clothing items.")
            bot.register_next_step_handler(message, process_clothing_description)
        except Exception as e:
            bot.reply_to(message, f"Sorry, there was an error saving the image. Please try again. Error: {str(e)}")
            bot.register_next_step_handler(message, process_clothing_image)
    else:
        bot.reply_to(message, "Please send an image of the clothing items.")
        bot.register_next_step_handler(message, process_clothing_image)

def process_clothing_description(message):
    user_id = message.from_user.id
    if user_id not in user_data:
        bot.reply_to(message, "Sorry, your session has expired. Please start over.")
        return

    user_data[user_id]['description'] = message.text
    bot.reply_to(message, "Thank you. Please provide your contact phone number.")
    bot.register_next_step_handler(message, process_phone_number)

def process_money_amount(message):
    user_id = message.from_user.id
    if user_id not in user_data or user_data[user_id].get('donation_type') != 'money':
        bot.reply_to(message, "Sorry, there was an error. Let's start over.")
        start_donation(message, 'money')
        return

    try:
        amount = float(message.text)
        user_data[user_id]['amount'] = amount
        bot.reply_to(message, "Thank you. Please provide the M-Pesa phone number you'd like to use for the donation.")
        bot.register_next_step_handler(message, process_mpesa_number)
    except ValueError:
        bot.reply_to(message, "Please enter a valid amount in Kenyan Shillings.")
        bot.register_next_step_handler(message, process_money_amount)

def process_mpesa_number(message):
    user_id = message.from_user.id
    if user_id not in user_data:
        bot.reply_to(message, "Sorry, your session has expired. Please start over.")
        return

    user_data[user_id]['phone'] = message.text
    initiate_mpesa_payment(message)

def initiate_mpesa_payment(message):
    user_id = message.from_user.id
    if user_id not in user_data:
        bot.reply_to(message, "Sorry, your session has expired. Please start over.")
        return

    amount = user_data[user_id]['amount']
    phone = user_data[user_id]['phone']

    # Here you would integrate with the M-Pesa API to initiate the payment
    # This is a placeholder for the actual API call
    # You would need to implement the actual M-Pesa API integration here
    success = simulate_mpesa_payment(amount, phone)

    if success:
        bot.reply_to(message, f"Great! An M-Pesa payment request for KES {amount} has been sent to {phone}. Please complete the payment on your phone.")
        bot.reply_to(message, "Once you've completed the payment, please send your location.")
        bot.register_next_step_handler(message, process_location)
    else:
        bot.reply_to(message, "Sorry, there was an error initiating the M-Pesa payment. Please try again later.")
        send_main_menu(message)

def simulate_mpesa_payment(amount, phone):
    # Simulate API request preparation
    print(f"Preparing M-Pesa payment request for KES {amount} to {phone}")

    # Simulated API call
    print("Initiating simulated M-Pesa API call...")
    time.sleep(2)  # Simulate network delay

    # Simulate potential errors
    if random.random() < 0.1:  # 10% chance of a network error
        print("Error: Network timeout. Please try again.")
        return False

    if not phone.startswith("+254") or len(phone) != 13:
        print("Error: Invalid phone number format. Must start with +254 and be 13 digits long.")
        return False

    if amount <= 0 or amount > 70000:
        print("Error: Invalid amount. Must be between 1 and 70,000 KES.")
        return False

    # Simulate successful payment
    success = random.random() < 0.9  # 90% chance of success

    if success:
        # Generate a mock transaction ID
        transaction_id = f"MPESA{datetime.now().strftime('%Y%m%d%H%M%S')}{random.randint(1000, 9999)}"

        print(f"Payment successful!")
        print(f"Transaction ID: {transaction_id}")
        print(f"Amount: KES {amount}")
        print(f"Phone: {phone}")
        print(f"Timestamp: {datetime.now().strftime('%Y-%m-%d %H:%M:%S')}")

        return True
    else:
        print("Payment failed. The user may have insufficient funds or there might be a problem with their M-Pesa account.")
        return False

def process_phone_number(message):
    user_id = message.from_user.id
    if user_id not in user_data:
        bot.reply_to(message, "Sorry, your session has expired. Please start over.")
        return

    user_data[user_id]['phone'] = message.text
    bot.reply_to(message, "Please send your location using the location sharing feature.")
    bot.register_next_step_handler(message, process_location)

def process_location(message):
    user_id = message.from_user.id
    if user_id not in user_data:
        bot.reply_to(message, "Sorry, your session has expired. Please start over.")
        return

    if message.location:
        user_data[user_id]['latitude'] = message.location.latitude
        user_data[user_id]['longitude'] = message.location.longitude
        fetch_donation_areas(message)
    else:
        bot.reply_to(message, "Please send your location using the location sharing feature.")
        bot.register_next_step_handler(message, process_location)

def fetch_donation_areas(message):
    user_id = message.from_user.id
    if user_id not in user_data:
        bot.reply_to(message, "Sorry, your session has expired. Please start over.")
        return

    cursor.execute("SELECT id, name FROM slum_areas")
    areas = cursor.fetchall()

    markup = InlineKeyboardMarkup()
    for area_id, area_name in areas:
        markup.add(InlineKeyboardButton(area_name, callback_data=f"area_{area_id}"))

    bot.send_message(message.chat.id, "Where would you like to donate?", reply_markup=markup)

@bot.callback_query_handler(func=lambda call: call.data.startswith('area_'))
def handle_area_selection(call):
    user_id = call.from_user.id
    if user_id not in user_data:
        bot.answer_callback_query(call.id, "Sorry, your session has expired. Please start over.")
        return

    area_id = call.data.split('_')[1]
    user_data[user_id]['slum_area_id'] = area_id
    save_donation(call.message, user_id)

def save_donation(message, user_id):
    if user_id not in user_data:
        bot.send_message(message.chat.id, "Sorry, your session has expired. Please start over.")
        return

    data = user_data[user_id]

    # Ensure all required fields are present
    required_fields = ['donation_type', 'phone', 'latitude', 'longitude', 'slum_area_id']
    if not all(field in data for field in required_fields):
        bot.send_message(message.chat.id, "Sorry, some information is missing. Please start the donation process again.")
        del user_data[user_id]
        return

    # Prepare the data for insertion
    donation_type = data['donation_type']
    phone = data['phone']
    location = f"{data['latitude']},{data['longitude']}"
    slum_area_id = data['slum_area_id']
    status = 'pending'
    created_at = updated_at = datetime.now()

    # Prepare the query
    query = """
    INSERT INTO donations
    (type, name, img, qty, phone, location, user_id, slum_area_id, status, created_at, updated_at)
    VALUES (%s, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s)
    """

    # Set default values
    name = ''
    img = ''
    qty = ''

    if donation_type == 'food':
        name = data.get('food_name', '')
        img = data.get('image_name', '')
        qty = str(data.get('quantity', ''))
    elif donation_type == 'water':
        name = 'Water'
        img = data.get('image_name', '')
        qty = str(data.get('quantity', ''))
    elif donation_type == 'clothing':
        name = 'Clothing'
        img = data.get('image_name', '')
        qty = data.get('description', '')  # Using description as quantity for clothing
    elif donation_type == 'money':
        name = 'Money'
        qty = str(data.get('amount', ''))

    values = (donation_type, name, img, qty, phone, location, user_id, slum_area_id, status, created_at, updated_at)

    try:
        cursor.execute(query, values)
        db.commit()

        # Move image from temp folder to upload folder if it exists
        if 'temp_image_path' in data and 'image_name' in data:
            final_image_path = os.path.join(UPLOAD_FOLDER, data['image_name'])
            shutil.move(data['temp_image_path'], final_image_path)

        bot.send_message(message.chat.id, "Thank you for your generous donation! We'll be in touch soon to arrange pickup or confirm your contribution.")
        # user_data[user_id] = {'just_donated': True}
        # send_main_menu(message)
    except mysql.connector.Error as err:
        bot.send_message(message.chat.id, f"An error occurred while saving your donation. Please try again later. Error: {err}")
        # If there's an error, remove the image from the temp folder if it exists
        if 'temp_image_path' in data and os.path.exists(data['temp_image_path']):
            os.remove(data['temp_image_path'])
    finally:
        if 'just_donated' not in user_data[user_id]:
            del user_data[user_id]

# Start the bot
if __name__ == "__main__":
    logger.info("Starting the bot")
    bot.polling()
    logger.info("Bot stopped")
